import 'package:cresce_client/http_requests/formaters/decoders.dart';
import 'package:cresce_client/http_requests/http_client.dart';

class LoginResultDto implements Serializable, Deserialize {
  final String organizationUrl;
  final String token;

  LoginResultDto({
    this.organizationUrl,
    this.token,
  });

  @override
  String serialize(Encoder encoder) {
    return encoder.encode(toMap());
  }

  @override
  Object deserialize(Map<String, dynamic> data) {
    return fromMap(data);
  }

  @override
  Object fromMap(Map<String, Object> map) {
    return LoginResultDto(
      organizationUrl: map['organizationUrl'],
      token: map['token'],
    );
  }

  @override
  Map<String, Object> toMap() {
    return {
      'organizationUrl': organizationUrl,
      'token': token,
    };
  }
}
