import 'package:cresce_client/authentication/credentials_dto.dart';
import 'package:cresce_client/authentication/login_result_dto.dart';
import 'package:cresce_client/http_requests/http_client.dart';

typedef OnLoginSuccessful(LoginResultDto result);
typedef OnLoginFailure();

class LoginServices {
  final HttpPost httpPost;

  const LoginServices(this.httpPost);

  void login(
    CredentialsDto credentials, {
    OnLoginSuccessful successCallback,
    OnLoginFailure failureCallback,
  }) {
    httpPost.post('api/v1/authentication/', credentials).then((value) {
      if (value.wasSuccess()) {
        successCallback?.call(
          value.deserialize<LoginResultDto>(LoginResultDto()),
        );
      } else {
        failureCallback?.call();
      }
    });
  }
}
