import 'package:cresce_client/http_requests/formaters/decoders.dart';

import 'cresce_client.dart';
import 'package:http/http.dart' as http;

class ServiceLocator {
  final String authority;
  HttpResultHandler _httpResultHandler;

  ServiceLocator(this.authority)
      : _httpResultHandler = HttpResultHandler(_getFormatter());

  void LogHttpRequestsToConsole() {
    _httpResultHandler = ResultLogger(_getFormatter());
  }

  LoginServices getLoginService() {
    return LoginServices(_getHttpPost(authority));
  }

  HttpPost _getHttpPost(String authority) {
    return HttpPost(
      authority,
      _getFormatter(),
      resultHandler: _httpResultHandler,
    );
  }

  static JsonFormatter _getFormatter() => JsonFormatter();
}

class ResultLogger extends HttpResultHandler {
  ResultLogger(Formatters formatters) : super(formatters);

  HttpResult handle(http.Response response) {
    var result = super.handle(response);
    print(result);
    return result;
  }
}
