import 'package:cresce_client/authentication/authentication.dart';
import 'package:cresce_client/cresce_client.dart';
import 'package:equatable/equatable.dart';
import 'package:test/test.dart';

import '../monitor.dart';

main() {
  EquatableConfig.stringify = true;
  Monitor monitor;
  LoginResultDto loginResult;
  ServiceLocator serviceLocator;

  setUp(() {
    monitor = Monitor(
      waitTime: const Duration(milliseconds: 10),
      tries: 10000,
    );

    serviceLocator = ServiceLocator('https://cresce.azurewebsites.net/');
  });

  void onSuccess(LoginResultDto result) {
    loginResult = result;
    monitor.signal();
  }

  void onFailure() {
    monitor.signal();
  }

  test('login in with valid credentials returns auth token', () async {
    var services = serviceLocator.getLoginService();

    services.login(
      CredentialsDto(user: 'myUser', password: 'myPass'),
      successCallback: onSuccess,
      failureCallback: onFailure,
    );
    await monitor.wait();

    expect(loginResult, isNotNull);
    expect(loginResult.organizationUrl, 'api/v1/myUser/organization/');
    expect(loginResult.token, isNotNull);
    expect(loginResult.token, isNotEmpty);
  });
}
